<template>

    <DocumentWrapper ref="wrap">
        <ListPage :desktop="4" class="q-pa-lg">
            <Form
                title="Create Danger Zone Rule"
                :fields="fields"
                v-model="model"
                @unknown="SubmitError"
                @auth="SubmitError"
                :on-submit="Submit"
                @success="Success"
            >

            </Form>
        </ListPage>
    </DocumentWrapper>

</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
import {Component, Vue} from 'vue-property-decorator';
import Form from "components/Form.vue";
import {actionFields, actionModel, ruleFields, ruleModel} from "src/classLibrary/Constants";
import DocumentWrapper from "components/Core/DocumentWrapper.vue";
import {ApiError} from "src/classLibrary/Core/Api";
import ListPage from "components/Core/ListPage.vue";
import {RuleActionResponse} from "src/classLibrary/APIModels/core/ruleActionResponse";
import {RuleTriggerResponse} from "src/classLibrary/APIModels/core/ruleTriggerResponse";
import {Atomic} from "src/classLibrary/Atomic";
import {RulePrincipalResponse} from "src/classLibrary/APIModels/core/rulePrincipalResponse";
import {SelectInput} from "src/classLibrary/FormTypes";

@Component({
    components: {ListPage, DocumentWrapper, Form}
})
export default class WorkerEnterDangerZone extends Vue {
    get Wrap(): DocumentWrapper {
        return this.$refs.wrap as any;
    }

    SubmitError(e: ApiError) {
        this.Wrap.SubmitError(e);
    }

    model = {
        valid: false,
        models: {
            ...actionModel,
            ...ruleModel,
        }
    }

    fields = [
        ...ruleFields,
        ...actionFields
    ];

    async created() {

        const token = await this.$auth.CoreToken;
        const r = await this.$coreApi.Get<string[]>(`Rule/labels?projectId=${this.PersistentStore.StoreValue.project}`,
            null, token
        )

        if (r.isErr()) {
            this.Wrap.SubmitError(r.unwrapErr());
            return;
        }
        const options = r.unwrap();
        (this.fields[2] as SelectInput).options = options;
    }

    async Submit(_: any) {
        const t = await this.$auth.CoreToken;

        const pid = this.PersistentStore.StoreValue.project;
        const actionTransaction = new Atomic(async () => {
            return await this.$coreApi.Post<RuleActionResponse>(`Action/${pid}`,
                {
                    name: 'Action for ' + this.model.models.name,
                    description: this.model.models.description,
                    actionType: this.model.models.actionType,
                    triggerType: 'WorkerEnter',
                    code: `function OnEvent(e) { return {
                        alertLevel: "${this.model.models.alertLevel}",
                        title: 'Worker entered Danger Zone',
                        body: \`${this.model.models.message}\`
                    } }`,
                    meta: "{}",
                    labels: this.model.models.labels,
                }, t);
        }, async (t: RuleActionResponse) => {
            return await this.$coreApi.QDelete(`Action/${t.id}`)
        })


        const triggerTraction = new Atomic(async () => {
            return await this.$coreApi.Post<RuleTriggerResponse>(`Trigger/${pid}`,
                {
                    name: 'Trigger for ' + this.model.models.name,
                    description: this.model.models.description,
                    type: 'WorkerEnter',
                    code: `function OnEvent(e){ return e.zone.danger;}`,
                    meta: "{}",
                    labels: this.model.models.labels,
                }, t);
        }, async (i: RuleTriggerResponse) => {
            return await this.$coreApi.QDelete(`Delete/${i.id}`);
        });


        const trigger = await triggerTraction.Do();
        const action = await actionTransaction.Do();

        if (trigger.isErr() || action.isErr()) {
            const e1 = await triggerTraction.Undo();
            if (e1.isSome()) {
                this.$q.notify({
                    icon: 'warning',
                    color: 'warning',
                    message: 'failed to delete trigger'
                })
            }
            const e2 = await triggerTraction.Undo();
            if (e2.isSome()) {
                this.$q.notify({
                    icon: 'warning',
                    color: 'warning',
                    message: 'failed to delete action'
                })
            }
            if (trigger.isErr())
                return trigger;
            return action;
        }

        return await this.$coreApi.Post<RulePrincipalResponse>(`Rule/${pid}`, {
            name: this.model.models.name,
            description: this.model.models.description,
            triggerType: 'WorkerEnter',
            labels: this.model.models.labels,
            meta: "{}",
            triggerId: trigger.unwrap().id,
            actionId: action.unwrap().id,
        }, t);
    }

    async Success(a: RulePrincipalResponse) {
        this.$q.notify({color: 'positive', message: `Successfully created rule ${a.name}`, icon: 'check'});
        await this.$router.push("/rule");
    }


}
</script>
